use std::collections::HashMap;

use super::{AccountName, UnitName};

#[derive(Debug, serde::Deserialize)]
#[serde(deny_unknown_fields)]
pub struct AccountSpec {
    pub title: Option<String>,
    pub description: Option<String>,

    pub annotations: Option<HashMap<String, String>>,

    pub unit: Option<UnitName>,
}

#[derive(Debug, serde::Deserialize)]
#[serde(deny_unknown_fields)]
pub struct UnitSpec {
    pub name: UnitName,
    pub precision: Option<u8>,
}

#[derive(Debug, serde::Deserialize)]
#[serde(deny_unknown_fields)]
pub struct SpecRoot {
    pub ledger_path: std::path::PathBuf,

    pub units: HashMap<UnitName, UnitSpec>,

    pub accounts: HashMap<AccountName, AccountSpec>,
}
